// CustomBrushView.cpp : implementation of the CCustomBrushView class
//

#include "stdafx.h"
#include "CustomBrush.h"

#include "CustomBrushDoc.h"
#include "CustomBrushView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include<math.h>
#include"ColorBrushDialog.h"
#include"OwnBrushDialog.h"
/////////////////////////////////////////////////////////////////////////////
// CCustomBrushView


IMPLEMENT_DYNCREATE(CCustomBrushView, CView)

BEGIN_MESSAGE_MAP(CCustomBrushView, CView)
	//{{AFX_MSG_MAP(CCustomBrushView)
	ON_COMMAND(ID_COLOR_CHANGECOLOR, OnBrushColorChange)
	ON_COMMAND(ID_BRUSH_MYOWNBRUSH, OnMyownbrush)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	
   ON_COMMAND_RANGE(ID_BRUSH_NONE, ID_BRUSH_DOTS, OnBrushMenuItems)

	END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomBrushView construction/destruction

CCustomBrushView::CCustomBrushView()
{
	// TODO: add construction code here
colorref=RGB(0,0,0);
}

CCustomBrushView::~CCustomBrushView()
{
}

BOOL CCustomBrushView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
    for(int j=0;j<8;j++)
    bmBits[j]=0xff;

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCustomBrushView drawing
 


 
void CCustomBrushView::OnDraw(CDC* pDC)
{
    	CCustomBrushDoc* pDoc = GetDocument();
	    ASSERT_VALID(pDoc);

     CRect clientrect;
	 CBrush brush,*poldbrush;
	 GetClientRect(&clientrect);
	 brush.CreateSolidBrush(RGB(191,191,191));
	 poldbrush=pDC->SelectObject(&brush);
	  pDC->Rectangle(clientrect);
	 pDC->SelectObject(poldbrush);
	 DrawRectangle(colorref,flagBrush);

}

/////////////////////////////////////////////////////////////////////////////
// CCustomBrushView printing

BOOL CCustomBrushView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCustomBrushView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCustomBrushView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CCustomBrushView diagnostics

#ifdef _DEBUG
void CCustomBrushView::AssertValid() const
{
	CView::AssertValid();
}

void CCustomBrushView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCustomBrushDoc* CCustomBrushView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCustomBrushDoc)));
	return (CCustomBrushDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCustomBrushView message handlers
void CCustomBrushView::DrawRectangle(COLORREF colorref,int flagBrush)
 {
       	int x1=200,y1=60,x2=400,y2=260;
   
        CBrush brush,* pOldBrush;
        CPen pen,*poldpen;
	    CBitmap bm; 
		CDC *pDC=GetDC();
		CreateCustomBrush(colorref,flagBrush,brush,pDC);
		pOldBrush = (CBrush*)pDC->SelectObject(&brush);
		pDC->Rectangle(x1,y1,x2,y2);
		pDC->SelectObject(pOldBrush);
		brush.DeleteObject();
		pDC->SetTextColor(RGB(0,0,0));
		// call a fuction for creating a brush
		CreateCustomBrush(colorref,flagBrush,brush,pDC);
		pOldBrush = (CBrush*)pDC->SelectObject(&brush);
		pDC->Rectangle(x1,y1,x2,y2);
		pDC->SelectObject(pOldBrush);
		brush.DeleteObject();
		pDC->SetTextColor(RGB(0,0,0));

       // for drawing borders
		
		pen.CreatePen(PS_SOLID,1,RGB(127,127,127));
		poldpen=pDC->SelectObject(&pen);
		pDC->MoveTo(x2+5,y1-5);
		pDC->LineTo(x1-5,y1-5);
		pDC->LineTo(x1-5,y2+5);
		pDC->SelectObject(poldpen);
		pen.DeleteObject();
        pen.CreatePen(PS_SOLID,1,RGB(255,255,255));
		poldpen=pDC->SelectObject(&pen);
		pDC->MoveTo(x2+5,y1-5);
		pDC->LineTo(x2+5,y2+5);
		pDC->LineTo(x1-5,y2+5);
		pDC->SelectObject(poldpen);
		pen.DeleteObject();

        // for drawing outer border
		pen.CreatePen(PS_SOLID,3,RGB(255,255,255));
		poldpen=pDC->SelectObject(&pen);
		pDC->MoveTo(x2+16,y1-15);
		pDC->LineTo(x1-20,y1-15);
		pDC->LineTo(x1-20,y2+39);
		pDC->SelectObject(poldpen);
		pen.DeleteObject();
        pen.CreatePen(PS_SOLID,2,RGB(127,127,127));
		poldpen=pDC->SelectObject(&pen);
		pDC->MoveTo(x2+20,y1-15);
		pDC->LineTo(x2+20,y2+40);
		pDC->LineTo(x1-20,y2+40);
		pDC->SelectObject(poldpen);
 		pen.DeleteObject();
       // drawing dem0brush
		pen.CreatePen(PS_SOLID,3,RGB(127,127,127));
		poldpen=pDC->SelectObject(&pen);
		pDC->MoveTo(x2-50,y2+15);
		pDC->LineTo(x1+50,y2+15);
		pDC->LineTo(x1+50,y2+35);
		pDC->SelectObject(poldpen);
		pen.DeleteObject();
        pen.CreatePen(PS_SOLID,2,RGB(255,255,255));
		poldpen=pDC->SelectObject(&pen);
		pDC->MoveTo(x2-50,y2+15);
		pDC->LineTo(x2-50,y2+35);
		pDC->LineTo(x1+50,y2+35);
		pDC->SelectObject(poldpen);
		pen.DeleteObject();
		pDC->SetBkMode(TRANSPARENT);
		pDC->DrawText("PatternBrush",CRect(x1+50,y2+15,x2-50,y2+35),DT_CENTER);
		
 }	   

void CCustomBrushView::OnBrushMenuItems(UINT nID)
{
	switch(nID)
	{
	case ID_BRUSH_NONE:
		//AfxMessageBox("Clicked on none");
		//CreateNullBrush to fill rectangle
		break;
   
   case ID_BRUSH_WHITE: 
		//CreateWhiteBrush to fill rectangle
		break;
   
   case ID_BRUSH_SQUARE:
	
	   		flagBrush=1;
			OnDraw(GetDC());
		break;
   
   case ID_BRUSH_CIRCLE:
            flagBrush=2;
			OnDraw(GetDC());
//              Invalidate(TRUE);  working but flashing
	  	break;
   	   
   case ID_BRUSH_DOTINCIRCLE   :
	        flagBrush=3;
			OnDraw(GetDC());

  		break;
   
   case ID_BRUSH_DOTINSQARE    :
	        flagBrush=4;
			OnDraw(GetDC());

    		break;
   
   case ID_BRUSH_DOTS          :
	        flagBrush=5;
			OnDraw(GetDC());

  		break;
   
	}
}

void CCustomBrushView::OnBrushColorChange() 
{
	CColorBrushDialog dlg(this);
	dlg.DoModal();
	
	
}
void CCustomBrushView::OnMyownbrush() 
{
	COwnBrushDialog dlg;
	dlg.DoModal();	
}


void CCustomBrushView::CreateCustomBrush(COLORREF color, int type, CBrush &brush, CDC *pDC)
{
	CBitmap bm1;
	switch(type)
	{
	case 1:
		{
	
			WORD HatchBits1[8]= { 0xff, 0xff, 0x81, 0xbd,0xbd,0xbd, 0x81, 0xff };
    		pDC->SetTextColor(color);
			bm1.CreateBitmap(8,8,1,1, HatchBits1);
			brush.CreatePatternBrush(&bm1);
		  
		}
	break;

	case 2:
		{
			WORD HatchBits1[8] = { 0xff, 0xff, 0xdd, 0xdb, 0xd7,0xcf, 0xd7, 0xdb };
			pDC->SetTextColor(color);
			bm1.CreateBitmap(8,8,1,1, HatchBits1);
			brush.CreatePatternBrush(&bm1);
		}
		break;
	case 3:
		{
			  WORD HatchBits1[8] = { 0xc3, 0xbd, 0x7e, 0x66, 0x66,
			  0x7e, 0xbd, 0xc3 };
			  pDC->SetTextColor(color);
			  bm1.CreateBitmap(8,8,1,1, HatchBits1);
			  brush.CreatePatternBrush(&bm1);
		}
	break;
	case 4:
		{
			  WORD HatchBits1[8] = { 0x00, 0x7e, 0x7e, 0x66, 0x66,
			  0x7e, 0x7e, 0x00 };
			  pDC->SetTextColor(color);
			  bm1.CreateBitmap(8,8,1,1, HatchBits1);
			  brush.CreatePatternBrush(&bm1);

		}
		break;
	case 5:
		{
			 WORD HatchBits1[8] ={0x66,0xa5,0xc3,0x0,0x0,0xc3,0xa5,0x66};
			 pDC->SetTextColor(color);
			 bm1.CreateBitmap(8,8,1,1, HatchBits1);
			 brush.CreatePatternBrush(&bm1);
		}
		break;
	}
}

